#include "FenPrincipale.h"

FenPrincipale::FenPrincipale()
{

    setMinimumSize(1300, 700);

    //menu du haut
    menuFichier = menuBar()->addMenu("&Fichier");
    actionQuitter = menuFichier->addAction("&Quitter");

    menuEdition = menuBar()->addMenu("&Action");
    nouvelleAnnee = menuEdition->addAction("&Passer au quinquennat suivant");
    Infos = menuEdition->addAction("&Infos");

    Aide = menuBar()->addMenu("Aide");
    Guide = Aide->addAction("&Guide");
    aPropos = Aide->addAction("À propos de...");

    BarreNav = addToolBar("Fichier");
    BarreNav->addAction(actionQuitter);

    BarreNav->addSeparator();
    BarreNav->addAction(Infos);
    BarreNav->addAction(Guide);
    BarreNav->addAction(nouvelleAnnee);

    aPropos->setIcon(QIcon("Apropos.png"));
    Infos->setIcon(QIcon("Infos.png"));
    nouvelleAnnee->setIcon(QIcon("AnneeSuivante.png"));
    Guide->setIcon(QIcon("Guide.png"));
    actionQuitter->setIcon(QIcon("Quitter.png"));


//fin menu haut

    //debut dock gauche


    QDockWidget *dock = new QDockWidget("Infos", this);
    addDockWidget(Qt::LeftDockWidgetArea, dock);

    QWidget *contenuDock = new QWidget;
    dock->setWidget(contenuDock);


    textInfoVote += "Votes " ;


    infoVotes = new QTextEdit();
    infoVotes->setReadOnly(true);
    infoVotes->setLineWrapMode(QTextEdit::NoWrap);



    compteEtat = 1000;
    compteFinalEtat.setNum(compteEtat);

    QString InfoTexte("Budget de l'état : ");
    InfoTexte += compteFinalEtat + "\n \n \n";


    InfoTexte += textInfoVote;







    infoVotes->setPlainText(InfoTexte);

    QVBoxLayout *dockLayout = new QVBoxLayout;


    dockLayout->addWidget(infoVotes);

    contenuDock->setLayout(dockLayout);

//fin dock gauche



    //zone centrale
    QWidget *zoneCentrale = new QWidget;
    frame = new QFrame(zoneCentrale);

    setCentralWidget(zoneCentrale);

    listePp = new QComboBox;
    listePp->addItem("communiste");
    listePp->addItem("Socialiste");
    listePp->addItem("Centriste");
    listePp->addItem("Droite");
    listePp->addItem("Extremiste de droite");
    listePp->addItem("Anarchiste");

    //QLabel politique("Votre politique");
    solidarite = new QRadioButton;
    solidarite->setChecked(true);
    capitalisme = new QRadioButton;
    nationalisation = new QRadioButton;
    immigration = new QRadioButton;


    budgetAideSocial = new QSpinBox;
    budgetAideSocial->setMaximum(99999);
    budgetServices = new QSpinBox;
    budgetServices->setMaximum(99999);
    budgetMilitaire = new QSpinBox;
    budgetMilitaire->setMaximum(99999);
    budgetEcole = new QSpinBox;
    budgetEcole->setMaximum(99999);
    budgetAutres = new QSpinBox;
    budgetAutres->setMaximum(99999);

    smic = new QSpinBox;
    smic->setMaximum(9999);

    impots = new QSpinBox;
    budgetAutres->setMaximum(99999);





    layoutPage = new QFormLayout;
    layoutPage->addRow("Votre idéologie de candidat \n", listePp);
    layoutPage->addRow("Budget pour les aides sociales(En milliards d'UM(Unité de Monnaie)) : ", budgetAideSocial);
    layoutPage->addRow("Budget pour les services publics et gratuit(police,pompiers...ect)(En milliards d'UM) : ", budgetServices);
    layoutPage->addRow("Budget pour l'armée(En milliards d'UM) : ", budgetMilitaire);
    layoutPage->addRow("Budget pour l'école(En milliards d'UM) : ", budgetEcole);
    layoutPage->addRow("Budget pour tout autres choses(En milliards d'UM) : ", budgetAutres);
    layoutPage->addRow("smic(UM) :", smic);


    layoutPage->addRow("Je favorise la solidarité(aide sociale...)", solidarite);
    layoutPage->addRow("Je favorise l'emploi grâce au capitalisme" ,capitalisme);
    layoutPage->addRow("Je favorise l'emploi grâce à  la nationalisation d'entreprises" ,nationalisation);
    layoutPage->addRow("Je lutte contre l'immigration" ,immigration);
    layoutPage->addRow("Impots sur les salaires(en %)", impots);



//crlmjrd@yahoo.com



    frame->setLayout(layoutPage);




    //fin zonne centrale







    //debut dock droite

    QDockWidget *dockDroite = new QDockWidget("Vos projets", this);
    addDockWidget(Qt::RightDockWidgetArea, dockDroite);

    QWidget *contenuDockDroite = new QWidget;
    dockDroite->setWidget(contenuDockDroite);


    QTextEdit *notes = new QTextEdit("Écrivez ce que vous voulez ici");


    QVBoxLayout *dockLayoutDroite = new QVBoxLayout;


    dockLayoutDroite->addWidget(notes);

    contenuDockDroite->setLayout(dockLayoutDroite);


    //fin dock droite


    connect(nouvelleAnnee, SIGNAL(triggered()), this, SLOT(anneeSuivante()));
    connect(actionQuitter, SIGNAL(triggered()), qApp, SLOT(quit()));
    connect(Infos, SIGNAL(triggered()), this, SLOT(infos()));
    connect(Guide, SIGNAL(triggered()), this, SLOT(aide()));
    connect(aPropos, SIGNAL(triggered()), this, SLOT(aProposDe()));


    candidatCoco = 1200;
    candidatSocialo = 1100;
    candidatCentre = 1350;
    candidatDroite = 1150;
    candidatFacho = 1000;
    candidatHumain = 1800;



    annee = 2012;

        InfosTexte = "Veuillez jouez un tour avant de consulter des résultats ;-)";
}







void FenPrincipale::anneeSuivante()
{


    int aideSocial = budgetAideSocial->value();
    int services = budgetServices->value();
    int militaire = budgetMilitaire->value();
    int ecole = budgetEcole->value();
    int autres = budgetAutres->value();
    int smicValeur = smic->value();
    int impotsValeur = impots->value();
    int indexListeOpinion = listePp->currentIndex();
    int reformes(2);

    if(solidarite->isChecked())
        reformes = 0;
    else if(capitalisme->isChecked())
        reformes = 1;
    else if(nationalisation->isChecked())
        reformes = 2;
    else if(immigration->isChecked())
        reformes = 3;

    int compteAnnee;

    compteAnnee = 1000 * impotsValeur;
    compteAnnee -= aideSocial;
    compteAnnee -= services;
    compteAnnee -= militaire;
    compteAnnee -= ecole;
    compteAnnee -= autres;
    compteAnnee -= 2 * smicValeur;

    compteEtat += compteAnnee;




    if (impotsValeur > 35)
    {
        candidatHumain -= 50;
        candidatDroite += 50;
        candidatFacho += 75;

    }
    else
    {
        candidatHumain += 150;
        candidatDroite += 50;
    }


    if (impotsValeur > 65)
    {
        candidatHumain -= 205;
        candidatDroite += 150;
        candidatFacho += 100;
        QMessageBox::warning(this, "Impots trop élevés", "Vos impots sont trop élevés, le peuple est énervé !");

    }




    if (compteEtat < 0)
    {
        candidatCoco += 163;
        candidatSocialo += 200;
        candidatCentre += 50;
        candidatHumain -= 50;
    }
    else
        candidatHumain += 100;

    if (compteEtat > 150)
    {
        int tt;
        tt += compteEtat/100;
        candidatHumain += tt;
    }
    else
        candidatHumain += 100;

    if (compteEtat < -150000)
    {
        candidatCoco += 450;
        candidatSocialo += 450;
        candidatCentre += 350;
        candidatFacho += 350;
        candidatDroite += 300;        

        candidatHumain -= 500;

        QMessageBox::warning(this, "Votre état est en faillite", "[Alerte] Votre état est très endetté, remontez les comptes très rapidement !");
    }

    if(aideSocial < 10000)
    {
        candidatCoco += 163;
        candidatSocialo += 200;
        candidatCentre += 50;
        candidatHumain -= 150;

    }
    else
        candidatHumain += 200;
        candidatDroite += 50;


    if(services < 8000)
    {
        candidatCoco += 163;
        candidatSocialo += 200;
        candidatCentre += 50;
        candidatHumain -= 150;
    }
    else
        candidatHumain += 200;


    if(militaire < 9000)
    {
        candidatDroite += 100;
        candidatFacho += 50;
        candidatHumain += 100;
        candidatHumain -= 150;

    }
    else
        candidatHumain += 100;
        candidatFacho -= 50;


    if(ecole < 4000)
    {
        candidatCoco += 250;
        candidatSocialo += 200;
        candidatCentre += 50;
        candidatHumain -= 150;
    }
    else
        candidatHumain += 100;


    if(autres < 7000)
    {
        candidatCoco += 140;
        candidatSocialo += 222;
        candidatCentre += 150;
        candidatFacho += 50;
        candidatHumain -= 150;

    }
    else
        candidatHumain += 100;

    if(autres < 7000 || ecole < 4000 || militaire < 9000 || services < 8000 || aideSocial < 10000)
        QMessageBox::warning(this, "Vos dépenses sont mal réparties.", "[Alerte] Vous n'attribuez pas assez d'importances à certaines de vos dépense !");




    if(smicValeur < 800)
    {
        candidatCoco += 140;
        candidatSocialo += 222;
        candidatHumain -= 150;
        QMessageBox::warning(this, "Le Salaire Minimum est trop bas", "Vous avez mis le smic trop bas, le peuple est en colère !");
    }

    if(smicValeur < 1900)
    {
        candidatCoco += 140;
        candidatSocialo += 222;
    }


    if(indexListeOpinion == 0 && nationalisation->isChecked())
        candidatHumain += 100;

    if(indexListeOpinion == 1 && solidarite->isChecked())
        candidatHumain += 100;


    if(indexListeOpinion == 2 && solidarite->isChecked())
        candidatHumain += 100;

    if(indexListeOpinion == 3 && capitalisme->isChecked())
        candidatHumain += 100;

    if(indexListeOpinion == 4 && immigration->isChecked())
        candidatHumain += 75;

    if(indexListeOpinion == 5 && solidarite->isChecked())
        candidatHumain += 75;




    if(impotsValeur > 45)
    {
    int changementProgressifsImpots(2);
    changementProgressifsImpots *= impotsValeur;
    candidatHumain -= changementProgressifsImpots;
    }


    int nbAleatoire(0);
    srand(time(0));
    nbAleatoire = rand() % 100;

    if(nbAleatoire < 10)
    {
        QMessageBox::warning(this, "Ridculisés en débats", "Le co-fondateur de votre partie s'est fait ridiculisé en débat face au candidat d'extrême droite.");
        candidatHumain -= 100;
        candidatFacho += 100;

    }

    if(nbAleatoire > 10 && nbAleatoire < 30)
    {
        QMessageBox::warning(this, "Un acte terroriste", "Un terroriste a attaqué la nuit dernière et a fait plus de 10 morts.");
        candidatHumain -= 100;
        candidatFacho += 100;
        candidatDroite += 100;

    }

    if(nbAleatoire > 30 && nbAleatoire < 50)
    {
        QMessageBox::warning(this, "Magouille", "Certains hommes politiques ont magouillé, et votre honnêteté à toute épreuve plait au Français");
        candidatHumain += 150;
        candidatCoco += 60;
        candidatSocialo += 50;

    }

    if(nbAleatoire > 50 && nbAleatoire < 60)
    {
        QMessageBox::warning(this, "Séisme !", "[ALERTE] Un séisme a touché le sud de la France. <br /> Couts de réparation : 55 000UM");
        candidatHumain += 150;
        candidatCoco += 60;
        candidatSocialo += 50;
        compteEtat -= 55000;

    }


    int nbAleatoirePLus(0);
    srand(time(0));
    nbAleatoirePLus = rand() % 200;


    int nbAleatoireMoins(0);
    srand(time(0));
    nbAleatoireMoins = rand() % 200;


    candidatHumain += nbAleatoirePLus;
    candidatHumain += nbAleatoireMoins;







    if(candidatCoco < 0)
        candidatCoco = 1;

    if(candidatSocialo < 0)
        candidatSocialo = 1;

    if(candidatCentre < 0)
        candidatCentre = 1;

    if(candidatFacho < 0)
        candidatFacho = 1;

    if(candidatHumain < 0)
        candidatHumain = 1;

    if(candidatDroite < 0)
        candidatDroite = 1;

    int t;
    t += candidatSocialo + candidatCoco + candidatCentre + candidatFacho + candidatHumain + candidatDroite;

    t/=100;

    double candidatDroitePC(candidatDroite);
    double candidatHumainPC(candidatHumain);
    double candidatFachoPC(candidatFacho);
    double candidatCentrePC(candidatCentre);
    double candidatCocoPC(candidatCoco);
    double candidatSocialoPC(candidatSocialo);

    candidatDroitePC /= t;
    candidatHumainPC /= t;
    candidatFachoPC /= t;
    candidatCentrePC /= t;
    candidatCocoPC /= t;
    candidatSocialoPC /= t;


    QString scoreDroite;
    QString scoreHumain;
    QString scoreFacho;
    QString scoreCentre;
    QString scoreCoco;
    QString scoreSocialo;


    compteFinalEtat.setNum(compteEtat);
    scoreDroite.setNum(candidatDroitePC);
    scoreHumain.setNum(candidatHumainPC);
    scoreFacho.setNum(candidatFachoPC);
    scoreCentre.setNum(candidatCentrePC);
    scoreCoco.setNum(candidatCocoPC);
    scoreSocialo.setNum(candidatSocialoPC);


    annee += 5;

    QString infoAnnee;

    infoAnnee.setNum(annee);

    InfosTexte = " Année " + infoAnnee + "\n Budget de l'état : ";
    InfosTexte += compteFinalEtat + " milliards d'euros \n \n \n";
    InfosTexte += "Résultats electoraux \n 1er tour \n Vous : " + scoreHumain + "\n Candidat de droite : " + scoreDroite;
    InfosTexte += "\n Candidat socialiste : " + scoreSocialo;
    InfosTexte += "\nCandidat centriste : " + scoreCentre;
    InfosTexte += "\nCandidat communiste : " + scoreCoco;
    InfosTexte += "\nCandidat d'extreme droite : " + scoreFacho;



    if(candidatCocoPC > candidatSocialoPC && candidatCocoPC > candidatCentrePC && candidatCocoPC > candidatDroitePC && candidatCocoPC > candidatFachoPC)
    {
        candidatCoco += candidatSocialoPC;
        candidatHumain += candidatCentrePC + candidatDroitePC;
        double candidatHumainn(candidatHumain);
        double candidatAdverse(candidatCoco);
        double er = candidatHumain + candidatCoco;
        er /= 100;
        candidatAdverse /= er;
        candidatHumainn /= er;

        QString candidatHumaine;
        QString candidatAdversee;


        candidatHumaine.setNum(candidatHumainn);
        candidatAdversee.setNum(candidatAdverse);

        InfosTexte += "\n\n2eme tour : \n Vous : " + candidatHumaine + "\n Candidat communiste : " + candidatAdversee;

        if(candidatHumainn < candidatAdverse)
        {
            QString defaite("vous avez perdu :");
            defaite += InfosTexte;
            QMessageBox::warning(this, "Vous avez perdu", defaite);
            close();
        }

    }

    if(candidatSocialoPC > candidatCocoPC  && candidatSocialoPC > candidatCentrePC && candidatSocialoPC > candidatDroitePC && candidatSocialoPC > candidatFachoPC)
    {
        candidatSocialo += 50;

        double er = candidatHumain + candidatSocialo;
        er /= 100;
        double candidatHumainn(candidatHumain);
        double candidatAdverse(candidatSocialo);
        candidatAdverse /= er;
        candidatHumainn /= er;

        QString candidatHumaine;
        QString candidatAdversee;


        candidatHumaine.setNum(candidatHumainn);
        candidatAdversee.setNum(candidatAdverse);

        InfosTexte += "\n\n2eme tour : \n Vous : " + candidatHumaine + "\n Candidat socialiste : " + candidatAdversee;

        if(candidatHumainn < candidatAdverse)
        {
            QString defaite("vous avez perdu :");
            defaite += InfosTexte;
            QMessageBox::warning(this, "Vous avez perdu", defaite);
            close();
        }

    }

    if(candidatCentrePC > candidatCocoPC  && candidatCentrePC > candidatSocialoPC  && candidatCentrePC > candidatDroitePC && candidatCentrePC > candidatFachoPC)
    {
        candidatCentre += 200;
        double er = candidatHumain + candidatCentre;
        er /= 100;
        double candidatHumainn(candidatHumain);
        double candidatAdverse(candidatCentre);
        candidatAdverse /= er;
        candidatHumainn /= er;

        QString candidatHumaine;
        QString candidatAdversee;


        candidatHumaine.setNum(candidatHumainn);
        candidatAdversee.setNum(candidatAdverse);

        InfosTexte += "\n\n2eme tour : \n Vous : " + candidatHumaine + "\n Candidat centriste : " + candidatAdversee;

        if(candidatHumainn < candidatAdverse)
        {
            QString defaite("vous avez perdu :");
            defaite += InfosTexte;
            QMessageBox::warning(this, "Vous avez perdu", defaite);
            close();
        }

    }



    if(candidatDroitePC > candidatCocoPC  && candidatDroitePC > candidatSocialoPC  && candidatDroitePC > candidatCentrePC && candidatDroitePC > candidatFachoPC)
    {
        candidatDroite += 40;
        candidatHumain += candidatSocialoPC + candidatCocoPC;
        double er = candidatHumain + candidatDroite;
        er /= 100;
        double candidatHumainn(candidatHumain);
        double candidatAdverse(candidatDroite);
        candidatAdverse /= er;
        candidatHumainn /= er;

        QString candidatHumaine;
        QString candidatAdversee;


        candidatHumaine.setNum(candidatHumainn);
        candidatAdversee.setNum(candidatAdverse);

        InfosTexte += "\n\n2eme tour : \n Vous : " + candidatHumaine + "\n Candidat de droite : " + candidatAdversee;

        if(candidatHumainn < candidatAdverse)
        {
            QString defaite("vous avez perdu :");
            defaite += InfosTexte;
            QMessageBox::warning(this, "Vous avez perdu", defaite);
            close();
        }

    }

    if(candidatFachoPC > candidatCocoPC  &&  candidatFachoPC > candidatSocialoPC  && candidatFachoPC > candidatCentrePC && candidatFachoPC > candidatDroitePC)
    {
        candidatFacho += candidatDroitePC;
        candidatFacho += 100;
        double er = candidatHumain + candidatFacho;
        er /= 100;
        double candidatHumainn(candidatHumain);
        double candidatAdverse(candidatFacho);
        candidatAdverse /= er;
        candidatHumainn /= er;

        QString candidatHumaine;
        QString candidatAdversee;


        candidatHumaine.setNum(candidatHumainn);
        candidatAdversee.setNum(candidatAdverse);

        InfosTexte += "\n\n2eme tour : \n Vous : " + candidatHumaine + "\n Candidat d'extrême droite : " + candidatAdversee;

        if(candidatHumainn < candidatAdverse)
        {
            QString defaite("vous avez perdu :");
            defaite += InfosTexte;
            QMessageBox::warning(this, "Vous avez perdu", defaite);
            close();
        }

    }

    infoVotes->setPlainText(InfosTexte);

    if(candidatHumainPC > 45)
    {

        candidatHumain -= 3000;
    }


}








void FenPrincipale::infos()
{
    QMessageBox::information(this, "Information", InfosTexte);
}


void FenPrincipale::aProposDe()
{
    QMessageBox::information(this, "Information", "Ce jeu a été créé par le fondateur de <a href=\"http://decouvronsensemble.free.fr/\">Decouvronsensemble</a>. \n Ce jeu a été créé le 25 mars 2012 ");
}

void FenPrincipale::aide()
{
    QMessageBox::information(this, "Information", "<h1>But du jeu</h1> Dans ce jeu ou simulateur d'élections, vous devez gérer le pays le plus logiquement et intelligemment  possible. \n <h2>Conseil : </h2> \n Faîtes attention à ne pas mettre l'état en deficit,\n à ne pas avoir des impots trop élevés,\n Consacrez bien une importance à <strong>chaque</strong> dépenses ! \n<h2>Les élections</h2>\nDès que vous avez fini vos réglages, passez au quinquennat suivant, des nouvelles élections seront éffectués, regardez le à droite, \nregardez aussi les comptes de l'état,\n vous serez dans tout les cas au 2eme tour face au candidat le mieux placé(que vous ayez 2% ou 54%), en revanche, si vous perdez au deuxième tour, un message vous avertira de votre défaite, et le programme, s'éteindra. ");
}



