#ifndef QUICHOISIR_H
#define QUICHOISIR_H

#include <QtGui>

class QuiChoisir : public QWidget
{
    Q_OBJECT

    public:
    QuiChoisir();

    public slots:
    void programmeMelenchon();
    void programmeSarkozy();
    void programmeHollande();
    void programmeLepen();
    void programmeBayrou();


    void programmePoutou();
    void programmeArthaud();
    void programmeJoly();
    void programmeCheminade();
    void programmeAignant();


    private:
    QPushButton *melenchon;
    QPushButton *sarkozy;
    QPushButton *hollande;
    QPushButton *lepen;
    QPushButton *bayrou;
    QPushButton *poutou;
    QPushButton *arthaud;
    QPushButton *joly;
    QPushButton *cheminade;
    QPushButton *aignant;

    QVBoxLayout *listeCandidat;




};

#endif // QUICHOISIR_H
