#include "Menu.h"


Menu::Menu()
{
    menu = new QVBoxLayout;
    jouer = new QPushButton("Jouer");
    quiChoisir = new QPushButton("Qui choisir 2012");
    license = new QPushButton("License");
    AproposDe = new QPushButton("À propos de");
    quitter = new QPushButton("Quitter");

    menu->addWidget(jouer);
    menu->addWidget(quiChoisir);
    menu->addWidget(license);
    menu->addWidget(AproposDe);
    menu->addWidget(quitter);

    setLayout(menu);
    setMinimumSize(200, 200);
    setMaximumSize(450, 550);

    connect(jouer, SIGNAL(clicked()), this, SLOT(jouerJeu()));
    connect(quiChoisir, SIGNAL(clicked()), this, SLOT(demarrerQuiChoisir()));
    connect(license, SIGNAL(clicked()), this, SLOT(voirLicense()));
    connect(AproposDe, SIGNAL(clicked()), this, SLOT(aProposDe()));
    connect(quitter, SIGNAL(clicked()), qApp, SLOT(quit()));


}

void Menu::jouerJeu()
{
    jeu.show();
}

void Menu::demarrerQuiChoisir()
{
    liste.show();
}

void Menu::voirLicense()
{
    QMessageBox::information(this, "License", "Politico2012 est sous license LGPL, il est totalement gratuit et libre, sa distribution et son copiage est le bienvenue.");

}

void Menu::aProposDe()
{
    QMessageBox::information(this, "Information", "Ce jeu a été créé par le fondateur de <a href=\"http://decouvronsensemble.free.fr/\">Decouvronsensemble</a>. \n Ce jeu a été créé le 25 mars 2012 ");
}
