#include "QuiChoisir.h"


QuiChoisir::QuiChoisir()
{
    melenchon = new QPushButton("Jean-Luc Mlénechon");
    sarkozy = new QPushButton("Nicolas Sarkozy");
    hollande = new QPushButton("François Hollande");
    lepen = new QPushButton("Marine Le Pen");
    bayrou = new QPushButton("François Bayrou");
    poutou = new QPushButton("Philippe Poutou");
    arthaud = new QPushButton("Nathalie Arhaud");
    joly = new QPushButton("Eva Joly");
    cheminade = new QPushButton("Jacques Cheminade");
    aignant = new QPushButton("Nicolas Dupont-Aignant");

    listeCandidat = new QVBoxLayout;


    listeCandidat->addWidget(melenchon);
    listeCandidat->addWidget(sarkozy);
    listeCandidat->addWidget(hollande);
    listeCandidat->addWidget(lepen);
    listeCandidat->addWidget(bayrou);
    listeCandidat->addWidget(poutou);
    listeCandidat->addWidget(arthaud);
    listeCandidat->addWidget(joly);
    listeCandidat->addWidget(cheminade);
    listeCandidat->addWidget(aignant);

    setLayout(listeCandidat);

    connect(melenchon, SIGNAL(clicked()), this, SLOT(programmeMelenchon()));
    connect(sarkozy, SIGNAL(clicked()), this, SLOT(programmeSarkozy()));
    connect(hollande, SIGNAL(clicked()), this, SLOT(programmeHollande()));
    connect(lepen, SIGNAL(clicked()), this, SLOT(programmeLepen()));
    connect(bayrou, SIGNAL(clicked()), this, SLOT(programmeBayrou()));
    connect(poutou, SIGNAL(clicked()), this, SLOT(programmePoutou()));
    connect(arthaud, SIGNAL(clicked()), this, SLOT(programmeArthaud()));
    connect(joly, SIGNAL(clicked()), this, SLOT(programmeJoly()));
    connect(cheminade, SIGNAL(clicked()), this, SLOT(programmeCheminade()));
    connect(aignant, SIGNAL(clicked()), this, SLOT(programmeAignant()));


}


void QuiChoisir::programmeMelenchon()
{
    QMessageBox::information(this, "Mélenchon", "<h1>Jean-Luc Mélenchon</h1> <br /> <strong>Candidats du FDG</strong> <br /> <strong>Situation politique : </strong> Gauche-Socialiste <br /><strong>Slogan de campaigne : </strong> Prenez le pouvoir <br /> <h3>Principaux points du projets :</h3> -Retraite à 60 ans <br />-école obligatoire de 3 à 18 ans<br />-Smic à 1700€");

}

void QuiChoisir::programmeSarkozy()
{
    QMessageBox::information(this, "Sarkozy", "<h1>Nicolas Sarkozy</h1> <br /> <strong>Candidats de l'UMP</strong> <br /> <strong>Situation politique : </strong> Droite <br /><strong>Slogan de campaigne : </strong> La France forte <br /> <h3>Principaux points du projets :</h3> -Préserver l'identité de la France <br />-Défendre les valeurs de la France");

}

void QuiChoisir::programmeHollande()
{
    QMessageBox::information(this, "Hollande", "<h1>François Hollande</h1> <br /> <strong>Candidats du PS</strong> <br /> <strong>Situation politique : </strong> Gauche - Socialiste <br /><strong>Slogan de campaigne : </strong> Le changement, c'est maintenant <br /> <h3>Principaux points du projets :</h3> -Construction de 2,5 millions de logements <br />-Création de 60 000 postes dans l'éducation<br />-Réforme sur la fiscalité");

}

void QuiChoisir::programmeLepen()
{
    QMessageBox::information(this, "Le Pen", "<h1>Marine Le Pen</h1> <br /> <strong>Candidats du FN</strong> <br /> <strong>Situation politique : </strong> Extrême Droite - Nationaliste <br /><strong>Slogan de campaigne : </strong> Oui, la France <br /> <h3>Principaux points du projets :</h3> -Expulsion des immigrés clandestins et des délinquants étrangers <br />-Restauration de services publics de qualité <br />-Sortie de l'euro");

}

void QuiChoisir::programmeBayrou()
{
    QMessageBox::information(this, "Bayrou", "<h1>François Bayrou</h1> <br /> <strong>Candidats du Modem</strong> <br /> <strong>Situation politique : </strong> Centre <br /><strong>Slogan de campaigne : </strong>Un pays uni, rien ne lui résiste <br /> <h3>Principaux points du projets :</h3> -Construction de 150 000 logements sociaux <br />-Élection des dirigeants européen au suffrage universel");

}

void QuiChoisir::programmePoutou()
{
    QMessageBox::information(this, "Poutou", "<h1>Philippe Poutou</h1> <br /> <strong>Candidats du NPA </strong> <br /> <strong>Situation politique : </strong> Gauche - Anticapitaliste <br /><strong>Slogan de campaigne : </strong>Nos vies valent plus que leurs profits / Aux capitalises de payer leurs crises <br /> <h3>Principaux points du projets :</h3> -Retraite à 60 ans <br />-Augmentation des salires de 300€ net <br />-Interdiction des licenciements");

}

void QuiChoisir::programmeArthaud()
{
    QMessageBox::information(this, "Arthaud", "<h1>Philippe Poutou</h1> <br /> <strong>Candidats de LO </strong> <br /> <strong>Situation politique : </strong> Gauche - Communiste <br /><strong>Slogan de campaigne : </strong>Une candidate communiste <br /> <h3>Principaux points du projets :</h3> -Retraite à 60 ans <br />-Interdiction des licenciements <br />-Nationalisation sans indemnité des entreprises des riches");

}

void QuiChoisir::programmeJoly()
{
    QMessageBox::information(this, "Joly", "<h1>Eva Joly</h1> <br /> <strong>Candidats de EELV </strong> <br /> <strong>Situation politique : </strong> Gauche - Écologiste <br /><strong>Slogan de campaigne : </strong>L'écologie, le vrai changement <br /> <h3>Principaux points du projets :</h3> -Création d'emplois <br />-Transition vers le VIème république : régime parlementaire fondé sur le scrutin proportionnel <br />-Création d'une Europe Fédérale");

}

void QuiChoisir::programmeCheminade()
{
    QMessageBox::information(this, "Cheminade", "<h1>Jacques Cheminade</h1> <br /> <strong>Candidats de ? </strong> <br /> <strong>Situation politique : </strong> Gauche ? <br /><strong>Slogan de campaigne : </strong>Un monde sans la city ni wall street <br /> <h3>Principaux points du projets :</h3> -Création d'une banque nationale pour les PME, hopitaux..ect <br />-Développement de l'afrique et de l'exploration spatiale");

}

void QuiChoisir::programmeAignant()
{
    QMessageBox::information(this, "Dupont-Aignant", "<h1>Nicolas Dupont-Aignant</h1> <br /> <strong>Candidats de ? </strong> <br /> <strong>Situation politique : </strong> Droite - Gaulliste <br /><strong>Slogan de campaigne : </strong>La france libre <br /> <h3>Principaux points du projets :</h3> -Supprimer les péages d'autoroute <br />-Remplacer les enseignants partant en retraire");
}
